<?php

/*******************************************
* Simple Livejournal
* Version 1.0
*  mamavrn.ru
* License - http://creativecommons.org/licenses/by-sa/3.0/ CC BY-SA 3.0
********************************************
* SimpleLivejournal.php
*******************************************/

if (!defined('SMF'))
	die('Hacking attempt...');

	/* Permission hook */
	function SimpleLivejournalPermissions(&$permissionGroups, &$permissionList)
	{
		loadLanguage('SimpleLivejournal');
		$permissionGroups['membergroup']['simple'] = array('SimpleLivejournalPer');
		$permissionGroups['membergroup']['classic'] = array('SimpleLivejournalPer');
		$permissionList['membergroup']['SimpleLivejournalPerPost'] = array(false, 'SimpleLivejournalPer', 'SimpleLivejournalPer');
	}

        /* Settings hook */
	function SimpleLivejournalSettings(&$config_vars)
	{
		global $txt, $modSettings; 
		loadLanguage('SimpleLivejournal');
		if (isset($config_vars[0])) $config_vars[] = array('title', 'simple_livejournal_name');  
		$config_vars[] = array('check', 'simple_livejournal_enable');
		$config_vars[] = array('text', 'simple_livejournal_login');
		$config_vars[] = array('text', 'simple_livejournal_password');
		$config_vars[] = '';
		$config_vars[] = array('check', 'simple_livejournal_announcements', 'subtext' => $txt['simple_livejournal_announcements_sub']);
		$config_vars[] = array('text', 'simple_livejournal_announclength', 'subtext' => $txt['simple_livejournal_announclength_sub']);			
		$config_vars[] = array('check', 'simple_livejournal_board_enable', 'subtext' => $txt['simple_livejournal_board_enable_sub']);
		$config_vars[] = array('text', 'simple_livejournal_boards', 'size' => 56, 'subtext' => $txt['simple_livejournal_boards_sub']);
		$config_vars[] = array('text', 'simple_livejournal_user_denied', 'size' => 56, 'subtext' => $txt['simple_livejournal_user_denied_sub']);
	}

	function SimpleLivejournal($msgOptions, $topicOptions, $posterOptions)
	{
		global $modSettings, $scripturl, $sourcedir, $context, $user_info, $txt, $smcFunc;

		loadLanguage('SimpleLivejournal');
		$context['SimpleLivejournalPerPost'] = allowedTo('SimpleLivejournalPerPost', $topicOptions['board']);
		if (!empty($modSettings['simple_livejournal_user_denied']))
			$user_denied = explode(',', $modSettings['simple_livejournal_user_denied']);

		else
			$user_denied = array();
	
		if (empty($modSettings['simple_livejournal_enable']) || empty($modSettings['simple_livejournal_login']) || empty($modSettings['simple_livejournal_password']) || $msgOptions['icon'] == 'moved' || empty($context['SimpleLivejournalPerPost']) || in_array($user_info['id'], $user_denied))
			return;

		else
		{
			if(!empty($modSettings['simple_livejournal_board_enable']) && !empty($modSettings['simple_livejournal_boards']))
				$boards_denied = explode(',', $modSettings['simple_livejournal_boards']);
			else
				$boards_denied = array();

			if(!in_array($topicOptions['board'], $boards_denied))
			{
				$subj = $msgOptions['subject'];
				$postbody = parse_bbc($msgOptions['body']); 
                                if(!empty($modSettings['simple_livejournal_announcements']))
				{
					if(!empty($modSettings['simple_livejournal_announclength']))
						$announclength = '500';
					else 
						$announclength = (int)$modSettings['simple_livejournal_announclength'];
					preg_match('~^(?>(?><[^>]*>\s*)*[^<]){0,' . 2 * $announclength . '}(?=\s)~s', $postbody, $m);  
					$postbody = $m[0] . '...';
				}

				$request = $smcFunc['db_query']('', '
					SELECT name
					FROM {db_prefix}boards
					WHERE id_board = {int:id}
					LIMIT 1',
				array(
						'id' => $topicOptions['board']
					)			
				);		
				$row = $smcFunc['db_fetch_row']($request);
				$boardname = $row[0];
				$smcFunc['db_free_result']($request);	

				$ljurl_url = $scripturl . '?topic=' . $topicOptions['id'] . '.0';
				$ljurl_url = '<a href="' . $ljurl_url . '">' . $ljurl_url . "</a>";
				$u_name = $modSettings['simple_livejournal_login'];
				$u_pass = $modSettings['simple_livejournal_password'];
				$src = '<br /><br /><i><small>' . str_replace('{source_url}', $ljurl_url, $txt['simple_livejournal_source']) . '</small></i>';
				$text = $postbody . $src; 
				include_once 'xmlrpc/xmlrpc.inc';
				$GLOBALS['xmlrpc_internalencoding'] = 'UTF-8';
				$lj = new xmlrpc_client('/interface/xmlrpc','www.livejournal.com',80);
				$lj->request_charset_encoding = 'UTF-8';
				$lj->return_type = 'phpvals';
				$chellange = $lj->send(new xmlrpcmsg('LJ.XMLRPC.getchallenge'));
				$c = $chellange->value();
				$data = array();
				$data['username'] = new xmlrpcval($u_name,'string');
				$data['auth_method'] = new xmlrpcval('challenge','string');
				$data['auth_challenge'] = new xmlrpcval($c['challenge'],'string');
				$data['auth_response']  = new xmlrpcval(md5($c['challenge'] . md5($u_pass)),'string');
				$data['ver'] = new xmlrpcval('1','string');
				$data['lineendings']=new xmlrpcval("\n",'string');
				$data['subject'] = new xmlrpcval($subj,'string');
				$data['event'] =  new xmlrpcval($text,'string');
				$data['day'] = new xmlrpcval(date('d'),'string');
				$data['mon'] = new xmlrpcval(date('m'),'string');
				$data['year'] = new xmlrpcval(date('Y'),'string');
				$data['hour'] = new xmlrpcval(date('H'),'string');
				$data['min'] = new xmlrpcval(date('i'),'string');
				$data['security'] = new xmlrpcval('public','string');
				$data['props'] = new xmlrpcval(array(
				'opt_preformatted' => new xmlrpcval(true,'boolean'),
				'opt_backdated' => new xmlrpcval(true,'boolean'),
				'taglist' => new xmlrpcval($context['forum_name'] . ', ' . $boardname,'string'),
				),'struct');
				$d = new xmlrpcval($data,'struct');
				$result = $lj->send(new xmlrpcmsg('LJ.XMLRPC.postevent', array($d)),0,'http11');
			}
		}
	}
?>